<?php
use KORA\Manager;
use KORA\KoraSearch;
/**
Copyright (2008) Matrix: Michigan State University

This file is part of KORA.

KORA is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

KORA is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

// Initial Version: Meghan McNeil, 2009
// Refactor: Joe Deming, Anthony D'Onofrio 2013

require_once('includes/includes.php');
Manager::Init();

Manager::RequireLogin();
Manager::RequireProject();
Manager::RequireScheme();

Manager::PrintHeader();

?>

<h2>Advanced Search</h2>

<?php
	//control name that do NOT have advanced search support
	$unsupportedAdvSearch = array('File','Image','Record Associator','Geolocator');
	
	//control names that CANNOT be sorted by
	$unsupportedSort = array('Text (Multi-Input)', 'List (Multi-Select)', 'Multi-Date', 'Date (Multi-Input)');
	
	//get controls that allow advanced search
	$cTable = 'p'.Manager::GetProject()->GetPID().'Control';
	$query = "SELECT $cTable.type AS class, $cTable.cid AS cid, $cTable.name AS name, control.file AS file,
			  control.name AS type FROM $cTable LEFT JOIN control ON ($cTable.type = control.class) WHERE
			  $cTable.advSearchable=1 AND $cTable.schemeid=".Manager::GetScheme()->GetSID().' AND control.name
			  NOT IN ("'.implode('","',$unsupportedAdvSearch).'") ORDER BY collid DESC,sequence';
	$query = $db->query($query);
	$controls = array();
	while ($results = $query->fetch_assoc()) {
		$controls[] = $results;
	}
	
	//get controls that allow sorting
	$sortControls = array();
	$sortQuery = "SELECT $cTable.type AS class, $cTable.cid AS cid, $cTable.name AS name, control.file AS file,
			  	control.name AS type FROM $cTable LEFT JOIN control ON ($cTable.type = control.class) WHERE
			  	$cTable.advSearchable=1 AND $cTable.schemeid=".Manager::GetScheme()->GetSID().' AND control.name
			  	NOT IN ("'.implode('","',$unsupportedSort).'") ORDER BY collid DESC,sequence';
	$sortQuery = $db->query($sortQuery);
	while ($sortResult = $sortQuery->fetch_assoc())
	{
		$sortControls[] = $sortResult;
	}
	
	
	KoraSearch::PrintKeywordSearchForm($sortControls,$unsupportedSort);
	KoraSearch::PrintAdvancedSearchForm($controls,$unsupportedAdvSearch,$sortControls,$unsupportedSort);
	
	Manager::PrintFooter();
?>