<?php 
use KORA\Manager;
use KORA\User;
/**
Copyright (2008) Matrix: Michigan State University

This file is part of KORA.

KORA is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

KORA is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. */

// Initial Version: Meghan McNeil, 2009
// Refactor: Joe Deming, Anthony D'Onofrio 2013

// This ajax file handles all requests related to a User Model 

require_once(__DIR__.'/../includes/includes.php');



Manager::Init();

if(Manager::CheckRequestsAreSet(['action']))
{
	$action = $_REQUEST['action'];
	
	//Handles updating a users information
	if ($action == 'updateUserInfo') 
	{
		Manager::RequireLogin();
		Manager::GetUser()->UpdateUser($_REQUEST['pw1'],$_REQUEST['pw2'],$_REQUEST['org'],
			$_REQUEST['name'],$_REQUEST['email'],$_REQUEST['lang']);
	} 

	//Handles a user loging in
	if ($action == 'userLogin' && Manager::CheckRequestsAreSet(['username','password']))
	{
		User::DoLogin();
	}
	
	//Handles activation of a user account
	if ($action == 'activateAccount' && Manager::CheckRequestsAreSet(['username','token']))
	{
		User::HandleAccountActivation($_REQUEST['username'],$_REQUEST['token']);
	}
	
	//Handles registration of a user account
	if ($action == 'registerAccount' && Manager::CheckRequestsAreSet(['username','password1','password2','email','realname','organization','language']))
	{
		//generates recaptcha form
	    recaptcha_get_html(PublicKey);
		//gets response from form
		$resp = recaptcha_check_answer (PrivateKey,
			$_SERVER["REMOTE_ADDR"],
			$_REQUEST["recaptcha_challenge_field"],
			$_REQUEST["recaptcha_response_field"]);
		//checks validity of response
		if (!$resp->is_valid) {
			echo "The reCAPTCHA wasn't entered correctly. Please refresh the Recaptcha box and retry again."; 
		}else{
			//registers account on success
			User::HandleRegistration();
		}
	
	}
	
	//Handles recovery of a user's password
	if ($action == 'recoverPassword' && Manager::CheckRequestsAreSet(['username']))
	{
			User::HandleRecoverPassword();
	
	}
	
	//Handles recovery of a username
	if ($action == 'recoverUser' && Manager::CheckRequestsAreSet(['email']))
	{
		User::HandleRecoverUsername();
	}
	
	//Handles reset of a user's password
	if ($action == 'resetPass' && Manager::CheckRequestsAreSet(['username','token','password1','password2']))
	{
		User::HandleResetSelfPassword();
	}
}
?>