<?php
use KORA\Manager;
use KORA\Record;
/*
Copyright (2008) Matrix: Michigan State University

This file is part of KORA.

KORA is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

KORA is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

// Initial Version: Caitlin Russ, 2010
// Refactor: Joe Deming, Anthony D'Onofrio 2013

require_once(__DIR__.'/includes/includes.php');

?>
<?php

function publicIngestForm($pid = '', $sid = '')
/*
PLEASE TAKE NOTE! We had to update the p1Data table, before it was an
int displaying the last number of an rid, now it displays the entire
rid string. The column was of type INT(10) now it needs to be VARCHAR(30)

If you can't ingest the second or third object into the p(pid)Data table, make sure its a VARCHAR!
*/
{
	if(!isset($_SESSION['formURL'])) $_SESSION['formURL'] = $_SERVER['PHP_SELF'];
	global $db;
	
	//check for valid project and scheme IDs
	if(empty($pid)) die("There is no project selected.");
	if(empty($sid)) die("There is no scheme selected.");
	
	$publicQuery = 'SELECT publicIngestion FROM scheme WHERE pid='.escape($pid).' AND schemeid='.escape($sid).' LIMIT 1';
	$checkPublic = $db->query($publicQuery);
    if(!($checkPublic->num_rows > 0))
    {
    	//no results, so the project or scheme IDs entered were invalid
    	die("Either the project or scheme you are trying to ingest into are invalid.");
    }
	
    //project and scheme IDs were valid, so check if the scheme is publically ingestible
    $assoc = $checkPublic->fetch_assoc();
	$isPublic = array_pop($assoc);
	if(!$isPublic) die("The scheme you are trying to ingest into is not publically ingestible.");
	
	//everything is OK, so continue!
	$rid = getNewRecordID($pid,$sid);
	
	if (isset($_REQUEST['ingestionForm']))
	{
		$schemeTest = $db->query('SELECT schemeid FROM scheme WHERE pid='.escape($pid).' AND schemeid='.escape($sid).' LIMIT 1');
		
		//check to make sure that the captcha is being entered correctly
		$privatekey = PRIVATE_KEY;
		
		$resp = recaptcha_check_answer ($privatekey,
		 $_SERVER["REMOTE_ADDR"],
		 $_REQUEST["recaptcha_challenge_field"],
		 $_REQUEST["recaptcha_response_field"]);
		
		//if inncorrect, display error message
		if(!$resp->is_valid)
		{
			$msg = "Error: Either the reCAPTCHa wasn't entered correctly or the form was submitted using a previous reCAPTCHA id.</br>Go back and try it again or refresh the reCAPTCHA id.";
			echo $msg;
		}
		//if correct, continue with ingestion
		else{
			if ($schemeTest->num_rows > 0)
			{
				$rid = getNewRecordID($pid,$sid);
				$form = new Record($pid, $sid, $rid);
				//$kid must be set because without it, scheme nextid will increase without a successful ingestion. SCHEME SHOULD NOT INCREMENT AT ALL HERE - James
				$form->SetPublicIngestion(true);
				$form->ingest(null, true);
				$form->SetPublicIngestion(false);
			}
			else
			{
				echo gettext('Invalid Project/Scheme ID passed');
			}
		}
	}
	else
	{
		?> 
		<!--Style tag needed for Preview Entry link since it doesnt have an href attribute.-->
		<style>#previewer {color:blue; text-decoration: underline; cursor:hand;}</style>
		
		<!--Colorbox-->
		<link href= "<?php echo baseURI."javascripts/colorbox/colorbox.css" ?>" rel="stylesheet" type="text/css" />
        <link rel="stylesheet" href="includes/mediaelement/build/mediaelementplayer.css" />
		<script type="text/javascript" src="//ajax.googleapis.com/ajax/libs/jquery/1.10.2/jquery.min.js"></script>
		<script type="text/javascript" src= "<?php echo baseURI."javascripts/colorbox/jquery.colorbox.js"?>" ></script>
		<script type="text/javascript" src= "<?php echo baseURI."javascripts/colorbox/jquery.colorbox-min.js"?>" ></script>
        <script src="includes/mediaelement/build/mediaelement-and-player.min.js"></script>
		<script type="text/javascript" src= "<?php echo baseURI."javascripts/control.js"?>"></script>
		<script type="text/javascript" src= "<?php echo baseURI."javascripts/search.js"?>"></script>
		<!--Control calls that may work-->
		<script type="text/javascript" src= "<?php echo baseURI."controls/associatorControl.js"?>" ></script>
		<script type="text/javascript" src= "<?php echo baseURI."controls/control.js"?>" ></script>
		<script type="text/javascript" src= "<?php echo baseURI."controls/listControl.js"?>" ></script>
		<script type="text/javascript" src= "<?php echo baseURI."controls/multiDateControl.js"?>" ></script>
		<script type="text/javascript" src= "<?php echo baseURI."controls/multiListControl.js"?>" ></script>
		<script type="text/javascript" src= "<?php echo baseURI."controls/multiTextControl.js"?>" ></script>
		<script type="text/javascript" src= "<?php echo baseURI."controls/dateControl.js"?>" ></script>
		<script type="text/javascript" src= "<?php echo baseURI."controls/fileControl.js"?>" ></script>
		<script type="text/javascript" src= "<?php echo baseURI."controls/imageControl.js"?>" ></script>
		<script type="text/javascript" src= "<?php echo baseURI."controls/textControl.js"?>" ></script>

	<?php
		//Creating the kora_globals div that holds all the global kora variables.
		$out = "<div id='kora_globals' ";
		if (Manager::GetUser()) { $out .= "uid='".Manager::GetUser()->GetUID()."' "; }
		if (Manager::GetProject()) { $out .= "pid='".Manager::GetProject()->GetPID()."' "; }
		if (Manager::GetScheme()) { $out .= "sid='".Manager::GetScheme()->GetSID()."' "; }
		if (Manager::GetRecord()) { $out .= "rid='".Manager::GetRecord()->GetRID()."' "; }
		$out .= "baseURI='".baseURI."' ";
		$out .= "></div>";
		
		print $out;
		
	?>
	
		<script type="text/javascript" >
		//This entire script is for preview and won't effect the actual submission.
		$(document).ready(function(){
			var formdata;
			$('#previewer').click(function(){
				var form = $("#ingestionForm");
				var newform = $(document.createElement("div"));
				
				//find all rows in the ingestion form
				form.find('.ctrlEdit').each(function(){
					var row = this;
					
					//get the name of the control from the left column of the row
					var name = $(row).find('strong').text();
					var right = $(row).find('#inlineInput');
					var kora_control = $(right).find('.kora_control');
					
					//search for 'kora control' in right column of row
					
					//If it is Multi-Date Control or Multi-Text Control its a select
					if($(right).find('.kora_control').size()!=0 && ($(kora_control).attr('kcclass') == 'MultiDateControl' || $(kora_control).attr('kcclass') == 'MultiTextControl' || $(kora_control).attr('kcclass') == 'AssociatorControl') )
					{
						var control = $(right).find('select');
					}
					else if($(right).find('.kora_control').size()!=0)
					{
						var control = $(right).find('.kora_control').children();
						if($(control).find('input').length!=0) control = $(control).find('input');
					}
					//if there isn't a 'kora control' it's a select
					else
					{
						var control = $(right).find('select');
					}
					
					var value;
					if($(control).is('#inlineInput select'))
					{
						console.log($(kora_control).attr('kcclass'));
						//find out whether select is multi-select
						if($(control)[0].multiple || ($(kora_control).attr('kcclass') == 'MultiDateControl'))
						{
							//if there's only one entry field
							if($(control).length==1 || $(control).length==2)
							{
								var multi="";
								//add all options that are selected to a string (in case it's a multi-select list)
								if(!($(right).find('tr').length>1))
								{
									$(control).find('option').each(function(){
										if($(this)[0].selected)
										{
											multi+=("<br>"+$(this).val());
										}
									});
								}
								else if($(kora_control).attr('kcclass') == 'MultiTextControl' || $(kora_control).attr('kcclass') == 'AssociatorControl')
								{
									//if it's a multi-text list, add all options that are selected to a string
										$(control).find('option').each(function(){
											//multi+=("<br>"+$(this).val());
											if($(this)[0].selected)
											{
												multi+=("<br>"+$(this).val());
											}
										});
								}

								value = multi;

							}
							//more than one field means multi-input date
							else
							{
								
								var multi="";
								if($(kora_control).attr('kcclass') == 'MultiDateControl')
								{
									//if it's a multi-date list, add all options that are selected to a string
									$('.kcmdc_curritems').find('option').each(function(){
										if($(this)[0].selected)
										{
											multi+=("<br>"+$(this).html());
										}
									});
								}
								value = multi;
							}
						}
						else
						{
							//list controls are simple (yay!)
							if($(control).length==1)
							{
								value = $(control).val();
							}
							//must be a date control
							else
							{
								value = control;
								var selectVal = '';
								var dateCount = 1;
								value.each(function(){
									//print name of month instead of number
									if(dateCount==1)
									{
										if(this.value==1) selectVal+= 'January ';
										if(this.value==2) selectVal+= 'February ';
										if(this.value==3) selectVal+= 'March ';
										if(this.value==4) selectVal+= 'April ';
										if(this.value==5) selectVal+= 'May ';
										if(this.value==6) selectVal+= 'June ';
										if(this.value==7) selectVal+= 'July ';
										if(this.value==8) selectVal+= 'August ';
										if(this.value==9) selectVal+= 'September ';
										if(this.value==10) selectVal+= 'October ';
										if(this.value==11) selectVal+= 'November ';
										if(this.value==12) selectVal+= 'December ';
									}
									else if(dateCount==2){
										selectVal+=(this.value+" ");
									}
									else{
										if(dateCount<4)selectVal+=this.value;
									}
									//keep track of what part of the date you're on
									dateCount++;
								});
								value = selectVal;
								
							}
						}
					}
					else
					{
						if($(control).is('input'))
						{
							//file control and image control
							if($(control).length==1)
							{
								value = $(control).val();
								
								//get rid of leading path and print out file name
								value = value.substring(12,800);
							}
							else
							{
								//text inputs are easy
								value = $(control).val();
							}
						}
						//don't output hidden fields
						else if($(control).is(':hidden')) return;
					}
					
					//create div element
					var element = $(document.createElement("div"));
					//if there's no name, the name shouldn't be output
					if(name==null)
					{
						if($(row).find('th').length!=0) element.html("<center><h3>"+$(row).html()+"</h3></center>");
						else element.html(value);
					}
					//otherwise output name and value
					else element.html(name+': '+value+'<br/><br/>');
					//add element to new form
					newform.append(element);
					$.colorbox({html:newform.html()});
				});
				
		});
				
	});
		</script>
		<?php

		//print out scheme's legal notice
		$legalQuery = 'SELECT legal FROM scheme WHERE pid='.escape($pid).' AND schemeid='.escape($sid).' LIMIT 1';
		$legalNotice = $db->query($legalQuery);
		while($result = $legalNotice->fetch_assoc())
		{
	
			if($result['legal']!=NULL)
			{
				echo "<strong>".gettext('Legal notice: ')."</strong>".$result['legal']."<br /><br />";
			}
		}
		
		//display the record
		$form = new Record($pid, $sid); 		//creates a new record
		$form->PrintRecordDisplay(true);  //Displays actual form, preview Entry link, and reCAPTCHA
		//When someone hits sumbit, this page is reloaded and the conditional above is true, the part is run.
	}
}

?>

